//   Verlies - ein Adventure im Retrodesign
//
//   Copyright (C) 2018-2022 Heiko Wolf
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License As published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE.  See the
//   GNU General Public License For more details.
//
//   You should have received a copy of the GNU General Public License along
//   With this program; if not, write to the Free Software Foundation, Inc.,
//   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//   Kontakt: projekte@kabelmail.net

//#pragma bank=3

#include "other.h"
#include "engine.h"
#include "text.h"
#include "hud.h"
#include "locations.h"
#include "gegner.h"

#include "daten/other/gameover.h"
#include "daten/other/kredits.h"
#include "daten/other/titel.h"
#include "daten/other/anleitung.h"
#include "daten/other/itembeschreibung.h"
#include "daten/other/statusanzeigebeschreibung.h"

#include "daten/tilesets/tilesets.h"
#include "daten/spritesets/v_spriteset_1.h"
#include "daten/txt/locations/locations.h"
#include "daten/lvl/lvldatfelsengrund.h"

#include "daten/txt/other/intro.h"

const UINT8 v_timerdat [35] = 
{
        50, 240, 49, 120, 106, 196, 246, 89, 24, 32, 130, 104, 22, 198, 165, 54, 109, 5, 13, 185, 
        97, 9, 48, 91, 64, 20, 30, 174, 164, 10, 66, 145, 3, 201, 83
};

void p_gameover (void) __banked
{
	HIDE_SPRITES;
	HIDE_WIN;
        set_bkg_tiles (0, 0, 20, 18, gameover);
        delay (130);
        waitpad (J_START);
        p_hud_init ();
        p_engine_loadTileset (BANK_2, 38, 81, grundtiles, BANK_3);
        p_engine_loadTileset (BANK_2, 82, 127, font, BANK_3); 
        p_engine_loadTileset (BANK_2, 8, 34, felsengrund_1, BANK_3);
        p_engine_loadSpriteset (BANK_2, 0, 127, v_spriteset_1, BANK_3);

        //v_gameover = TRUE; 
        v_slp = v_smlp;
        v_lvl = 1; v_info = FALSE; v_bosskampf = FALSE; v_kampf = FALSE;
        if (v_spr == 0) ++v_spr;

        v_keyflag = 1;
        p_engine_loadMap (v_lvl1a, BANK_5, BANK_3);
        v_region = 1;

        p_engine_changeLvl (1, 112, 96);
        v_keyflag = 0;
        p_gui_show_location (lfelsengrund);

        p_gegner_init ();
        p_hud_show ();

        DISPLAY_ON;
        SHOW_BKG;
        SHOW_SPRITES;
}

///wartet auf Steuerung unten
void p_engine_down (void) __banked
{
        delay (200);
        waitpad (J_DOWN);
}

void p_engine_A (void) __banked
{
        delay (200);
        waitpad (J_A);
}

///Startintro
void p_intro (void) __banked
{
        set_bkg_tiles (0, 0, 20, 18, kredits);
        delay (3000);
        set_bkg_tiles (0, 0, 20, 18, titel);
        delay (4000);
        set_bkg_tiles (0, 0, 20, 18, anleitung);
        p_engine_down ();
        set_bkg_tiles (0, 0, 20, 18, itembeschreibung);
        p_engine_down ();
        set_bkg_tiles (0, 0, 20, 18, statusanzeigebeschreibung);
        p_engine_A ();        
        p_engine_set_txt (intro);
        p_engine_A ();
        p_engine_after_txt ();
}

///"zufällige" Zahl ermitteln
UINT8 p_zahl (void) __banked
{
        for (v_a = 0; v_a <= 36; ++v_a)
	{
	       if (v_timer == v_timerdat [v_a]) return 1;
        }    
        return 0;  
}

